var Ball = (function (_super) {
    __extends(Ball, _super);
    function Ball() {
        _super.call(this);
        this.radius = 0;
    }
    var d = __define,c=Ball,p=c.prototype;
    p.createChildren = function () {
        _super.prototype.createChildren.call(this);
        if (this._block != null) {
            this.x += this._block.x + this._block.width / 2;
            this.y += this._block.y + this._block.height / 2;
            this.updateBlock();
        }
        if (Ball._def_radius == 0) {
            Ball._def_radius = this.radius;
        }
    };
    p.updateBlock = function () {
        if (this._block != null) {
            this.anchorOffsetX = this._block.x + this._block.width / 2;
            this.anchorOffsetY = this._block.y + this._block.height / 2;
            this.radius = this._block.width / 2;
            this.removeChild(this._block);
            this._block = null;
        }
    };
    //检查碰撞
    Ball.collision = function (a, b) {
        var d = egret.Point.distance(new egret.Point(a.x, a.y), new egret.Point(b.x, b.y));
        return d <= (a.radius + b.radius);
    };
    Ball._def_radius = 0;
    return Ball;
}(eui.Component));
egret.registerClass(Ball,'Ball');
var MoveBall = (function (_super) {
    __extends(MoveBall, _super);
    function MoveBall() {
        _super.call(this);
        this.moveVector = null;
        this.rebound = 0;
        this.moveSpeed = 0;
    }
    var d = __define,c=MoveBall,p=c.prototype;
    p.resetBall = function (i, mini) {
        if (mini === void 0) { mini = false; }
        if (mini) {
            this.skinName = "resource/skins/Balls/BallM" + i + "Skin.exml";
        }
        else {
            this.skinName = "resource/skins/Balls/Ball" + i + "Skin.exml";
        }
        this.updateBlock();
        this.moveVector = null;
    };
    p.onUpdate = function (dt) {
        if (this.moveVector == null) {
            return;
        }
        if (this.visible == false) {
            return;
        }
        this.moveSpeed = DataManager.getInstance().BallSpeed;
        var x = this.x + this.moveSpeed * dt * this.moveVector.x;
        var y = this.y + this.moveSpeed * dt * this.moveVector.y;
        if (this.rebound > 0) {
            var b = Game.getInstance().checkInRange(x, y, this.radius, this);
            if (b == 1 || b == 3) {
                if (this.handleRebound() != 0) {
                    this.moveVector.x = -this.moveVector.x;
                    x += this.moveSpeed * dt * this.moveVector.x;
                    Sound.getInstance().Play_Qiang();
                }
            }
            else if (b == 2 || b == 4) {
                if (this.handleRebound() != 0) {
                    this.moveVector.y = -this.moveVector.y;
                    y += this.moveSpeed * dt * this.moveVector.y;
                    Sound.getInstance().Play_Qiang();
                }
            }
        }
        else {
            if (this.rebound < 0) {
                if (this.x < -300 || this.x > this.stage.stageWidth + 300
                    || this.y < -300 || this.y > this.stage.stageHeight + 300) {
                    this.parent.removeChild(this);
                    this.skinName = null;
                }
            }
        }
        this.x = x;
        this.y = y;
    };
    p.handleRebound = function () {
        if (this.rebound > 0) {
            this.rebound -= 1;
        }
        if (this.rebound == 0) {
            //游戏没有结束，那么飞出去就直接结束了
            Game.getInstance().gameOver(false);
        }
        return this.rebound;
    };
    p.setMoveVector = function (vector) {
        this.moveVector = vector;
        if (vector != null) {
            this.moveVector.normalize(1);
            this.rebound = DataManager.getInstance().Rebound;
        }
    };
    return MoveBall;
}(Ball));
egret.registerClass(MoveBall,'MoveBall');
var Jewel = (function (_super) {
    __extends(Jewel, _super);
    function Jewel(i) {
        _super.call(this);
        this.I = 0;
        this.skinName = "resource/skins/Balls/Jewel" + i + "Skin.exml";
        this.I = i;
    }
    var d = __define,c=Jewel,p=c.prototype;
    return Jewel;
}(Ball));
egret.registerClass(Jewel,'Jewel');
var Jewel2 = (function (_super) {
    __extends(Jewel2, _super);
    function Jewel2() {
        _super.call(this, 200);
    }
    var d = __define,c=Jewel2,p=c.prototype;
    return Jewel2;
}(Jewel));
egret.registerClass(Jewel2,'Jewel2');
var Jewel3 = (function (_super) {
    __extends(Jewel3, _super);
    function Jewel3(i) {
        _super.call(this, i);
        this.I = 0;
        this.I = i;
    }
    var d = __define,c=Jewel3,p=c.prototype;
    p.updateBlock = function () {
        _super.prototype.updateBlock.call(this);
        this.radius = this.radius * 1.5;
    };
    return Jewel3;
}(Jewel));
egret.registerClass(Jewel3,'Jewel3');
