var egs;
(function (egs) {
    var BehaviourGroup = (function (_super) {
        __extends(BehaviourGroup, _super);
        function BehaviourGroup() {
            _super.call(this);
        }
        var d = __define,c=BehaviourGroup,p=c.prototype;
        return BehaviourGroup;
    }(Array));
    egs.BehaviourGroup = BehaviourGroup;
    egret.registerClass(BehaviourGroup,'egs.BehaviourGroup');
    var Behaviour = (function () {
        //Component
        function Behaviour() {
            this._owner = null;
        }
        var d = __define,c=Behaviour,p=c.prototype;
        d(p, "Owner"
            ,function () {
                return this._owner;
            }
            ,function (value) {
                this._owner = value;
            }
        );
        p.onStart = function () {
        };
        p.onUpdate = function (dt) {
        };
        p.onRemove = function () {
        };
        //protected 
        p.getObjById = function (id) {
            return this.Owner[id];
        };
        p.getObjByIdAs = function (id) {
            var find = this.Owner[id];
            if (find != null) {
                return find;
            }
            else {
                return null;
            }
        };
        p.getBehaviour = function (_class) {
            return _getBehaviour(_class, this.BehaviourGroup);
        };
        p.getBehaviours = function (_class) {
            return _getBehaviours(_class, this.BehaviourGroup);
        };
        p.getBehaviourFromAll = function (_class) {
            return _getBehaviour(_class, _behaviourlist);
        };
        p.removeSelf = function () {
            removeBehaviourScript(this);
        };
        d(p, "BehaviourGroup"
            ,function () {
                return getBehaviourGroup(this.Owner);
            }
        );
        p.CallFunction = function (fun_name) {
            var argArray = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                argArray[_i - 1] = arguments[_i];
            }
            var behaviours = getBehaviourGroup(this.Owner);
            for (var i = 0; i < behaviours.length; i++) {
                var behaviour = behaviours[i];
                var fun = behaviour[fun_name];
                if (fun != null) {
                    fun.call.apply(fun, [behaviour].concat(argArray));
                }
            }
        };
        p.CallFunFromAll = function (fun_name) {
            var argArray = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                argArray[_i - 1] = arguments[_i];
            }
            var behaviours = _behaviourlist;
            for (var i = 0; i < behaviours.length; i++) {
                var behaviour = behaviours[i];
                var fun = behaviour[fun_name];
                if (fun != null) {
                    fun.call.apply(fun, [behaviour].concat(argArray));
                }
            }
        };
        p.SetProps = function (props) {
            for (var key in props) {
                this.Owner[key] = props[key];
            }
        };
        return Behaviour;
    }());
    egs.Behaviour = Behaviour;
    egret.registerClass(Behaviour,'egs.Behaviour');
    var _behaviourlist = new BehaviourGroup();
    function addBehaviourScript(target, script) {
        if (target == null) {
            throw new Error("egs.addBehaviourScript: param{target} is null ");
            return;
        }
        createTick();
        var group = getBehaviourGroup(target);
        if (group == null) {
            group = new BehaviourGroup();
            target["BehaviourGroup"] = group;
        }
        script.Owner = target;
        group.push(script);
        _behaviourlist.push(script);
        script["onStart"]();
        return script;
    }
    egs.addBehaviourScript = addBehaviourScript;
    function removeBehaviourScript(script) {
        var group = getBehaviourGroup(script.Owner);
        if (group != null) {
            var index = group.indexOf(script);
            if (index >= 0) {
                group.splice(index, 1);
                _behaviourlist.splice(_behaviourlist.indexOf(script), 1);
                script["onRemove"]();
                script.Owner = null;
                for (var p in script) {
                    delete script[p];
                }
            }
        }
        return script;
    }
    egs.removeBehaviourScript = removeBehaviourScript;
    function clearBehaviourScripts(target) {
        if (target == null) {
            throw new Error("egs.addBehaviourScript: param{target} is null ");
            return;
        }
        var group = getBehaviourGroup(target);
        if (group != null) {
            for (var i = group.length - 1; i >= 0; i--) {
                removeBehaviourScript(group[i]);
            }
        }
    }
    egs.clearBehaviourScripts = clearBehaviourScripts;
    function getBehaviourGroup(obj) {
        if (obj["BehaviourGroup"] == null) {
            return null;
        }
        return obj["BehaviourGroup"];
    }
    function createTick() {
        if (_lasttimestamp != -1) {
            return;
        }
        egret.startTick(onUpdate, this);
        _lasttimestamp = 0;
    }
    var _lasttimestamp = -1;
    function onUpdate(timestamp) {
        var dt = (timestamp - _lasttimestamp) / 1000;
        _lasttimestamp = timestamp;
        _onUpdateBehaviourGroupChildren(_behaviourlist, dt);
        return true;
    }
    //遍历所有的处理器
    function _onUpdateBehaviourGroupChildren(behaviourGroup, dt) {
        var checkindex;
        for (var i = behaviourGroup.length - 1; i >= 0; i--) {
            var behaviour = behaviourGroup[i];
            if (behaviour == null) {
                continue;
            }
            var group = getBehaviourGroup(behaviour.Owner);
            if (group != null) {
                if (_BehaviourGroupContains(group, behaviour)) {
                    behaviour["onUpdate"](dt);
                }
                else {
                    removeBehaviourScript(behaviour);
                }
            }
            else {
                removeBehaviourScript(behaviour);
            }
        }
    }
    function _BehaviourGroupContains(behaviourGroup, behaviour) {
        return behaviourGroup.indexOf(behaviour) >= 0;
    }
    function _getBehaviour(_class, behaviourGroup) {
        var ret = null;
        for (var i = 0; i < behaviourGroup.length; i++) {
            var obj = behaviourGroup[i];
            if (obj.constructor.name == _class.name) {
                ret = obj;
                break;
            }
        }
        return ret;
    }
    function _getBehaviours(_class, behaviourGroup) {
        var ret = [];
        for (var i = 0; i < behaviourGroup.length; i++) {
            var obj = behaviourGroup[i];
            if (obj.name == _class.name) {
                ret.push(obj);
            }
        }
        return ret;
    }
})(egs || (egs = {}));
Object.defineProperty(egret.DisplayObject.prototype, 'addBehaviour', {
    value: function (behaviour) {
        egs.addBehaviourScript(this, behaviour);
    }
});
